unit Unit1;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Data.DB, WEBLib.CDS, WEBLib.DB, Vcl.StdCtrls, WEBLib.StdCtrls, Vcl.Controls, Vcl.Grids,
  WEBLib.DBCtrls;

type
  TForm1 = class(TWebForm)
    WebDBGrid: TWebDBGrid;
    btn: TWebButton;
    WebDataSource: TWebDataSource;
    WebClientDataSet: TWebClientDataSet;
    WebClientDataSetID: TIntegerField;
    WebClientDataSetDescription: TStringField;
    btn1: TWebButton;
    procedure btn1Click(Sender: TObject);
    procedure btnClick(Sender: TObject);
    procedure WebFormCreate(Sender: TObject);
    procedure WebDBGridGetCellChildren(Sender: TObject; ACol, ARow: Integer;
      AField: TField; AValue: string; AElement: TJSHTMLElementRecord);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure ButtonClick(event: TJSEvent);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btn1Click(Sender: TObject);
//var
//  I: Integer;
begin
// for I := 1 to WebClientDataSet.RecordCount do
//  begin
//    WebDBGrid.AddButton(3,i,'BUY');
//  end;
end;

procedure TForm1.btnClick(Sender: TObject);
var
  nCount: Integer;
begin
  nCount := WebClientDataSet.RecordCount;
  WebClientDataSet.Insert;
  WebClientDataSet.FieldByName('ID').Asinteger := nCount;
  WebClientDataSet.FieldByName('Description').AsString := 'Record ' + nCount.ToString;
  WebClientDataSet.Post;
  //WebDBGrid.AddButton(3,1,'Delete');
end;

procedure TForm1.ButtonClick(event: TJSEvent);
begin
  ShowMessage('clicked button:'+TJSHTMLElement(event.target)['data']);
end;

procedure TForm1.WebDBGridGetCellChildren(Sender: TObject; ACol, ARow: Integer;
  AField: TField; AValue: string; AElement: TJSHTMLElementRecord);
var
  el: TJSHTMLElement;
begin
  if (ACol = 2) and (ARow > 0) then
  begin
    el := TJSHTMLElement(document.createElement('INPUT'));
    el['type'] := 'BUTTON';
    el['value'] := 'BUY';
    el['data'] := ARow.ToString;
    el.addEventListener('click',@ButtonClick);
    AElement.element.appendChild(el);
  end;
end;

procedure TForm1.WebFormCreate(Sender: TObject);
begin
  WebClientDataSet.Open;
end;

end.
